<?php
namespace Teknisa\CMP\Controllers;

use \Setforms2\Shared\ORM\DateTime;
use Exception;

class DataProcessamento 
{
    protected $dataProcessamentoService;
    
    public function __construct($dataProcessamentoService) 
    {
        $this->dataProcessamentoService = $dataProcessamentoService;
    }
    
    /**
     * Metodo para buscar a data de processamento da filial
     * Verifica se a filial logada é uma central de compras. 
     * Nesse caso, retorna a data atual, ao contrário, retorna a data de 
     * processamento da filial, considerando as tabelas PARAMGERAL e PARAMFILIAL
     * 
     * @param {string} $cdfilial Código da Filial
     * 
     * @return {date} Data de processamento da Filial
     * 
    */
    public function getDataprocessamento($cdfilial)
    {
        try {
            if($this->dataProcessamentoService->verificaFilialCentral(null)) {
                return DateTime::createFromFormat("d/m/Y", date('d/m/Y'))->format('Y/m/d');
            } else {
                $dataproc = $this->dataProcessamentoService->getDataProcessamento($cdfilial);
                return DateTime::createFromFormat("d/m/Y", $dataproc)->format('Y/m/d');
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
}
